import { p as J } from "./pdf-97UbtKC2.js";
import { U as K, s as Q } from "./usePrinter-BEVwOH5x.js";
import { c as U, a as j, t as $, w as ee, p as te, u as ae, S as X, M as P, f as q, H as ie, E as le, i as re, Y as se, V as ne, Z as oe, s as ce, _ as he, d as de, A as ue, b as ge, q as fe, P as me, $ as Ie, r as be, e as Ne, y as xe, K as _e, x as Fe, a0 as ye, o as Ae, v as Le, D as Ce, z as Se } from "./index-fMHmzYJu.js";
import { D as ke } from "./DataTable-CzvZIRDs.js";
import { _ as we } from "./Title-BxitYokc.js";
import { _ as Oe, u as ve } from "./Tooltip-DTntJRyb.js";
import { _ as Ge } from "./Shape-qXMEmkXY.js";
import ze from "./BaseIcon-Dz58O3w1.js";
import pe from "./vue-ui-table-sparkline-h4J419FI.js";
import Me from "./vue-ui-skeleton-DiJmBrEY.js";
import { S as Pe } from "./Slicer-CnIWgBPY.js";
import Te from "./vue-ui-accordion-CVzTuENA.js";
import { u as Z } from "./useNestedProp-lzTC0cjC.js";
import { resolveComponent as T, openBlock as l, createElementBlock as r, normalizeClass as M, normalizeStyle as L, createVNode as Y, createCommentVNode as c, createBlock as V, createSlots as Ve, withCtx as z, renderSlot as v, normalizeProps as W, guardReactiveProps as B, createElementVNode as u, Fragment as I, renderList as b, toDisplayString as S, withDirectives as Re, vModelCheckbox as De, createTextVNode as Ee } from "vue";
import { _ as He } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const We = U(), Be = {
  name: "vue-ui-xy",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  components: {
    DataTable: ke,
    Shape: Ge,
    Title: we,
    Tooltip: Oe,
    UserOptions: K,
    BaseIcon: ze,
    TableSparkline: pe,
    Skeleton: Me,
    Slicer: Pe,
    Accordion: Te
  },
  data() {
    this.dataset.forEach((h, f) => {
      [null, void 0].includes(h.series) && this.error({
        componentName: "VueUiXy",
        type: "datasetSerieAttribute",
        property: "series (number[])",
        index: f
      });
    });
    const i = Math.max(...this.dataset.map((h) => h.series.length)), s = {
      start: 0,
      end: i
    };
    return {
      themePalettes: j,
      themes: $,
      slicerStep: 0,
      selectedScale: null,
      CTX: null,
      CANVAS: null,
      opacity: ee,
      useSafeValues: !0,
      palette: te,
      height: 600,
      width: 1e3,
      viewBox: "0 0 1000 600",
      clientPosition: {
        x: 0,
        y: 0
      },
      canvasClientPosition: {
        x: 0,
        y: 0
      },
      icons: {
        line: "line",
        bar: "bar",
        plot: "plot"
      },
      isFullscreen: !1,
      isPrinting: !1,
      isImaging: !1,
      isTooltip: !1,
      mutableConfig: {
        dataLabels: {
          show: !0
        },
        showTooltip: !0,
        showTable: !1,
        isStacked: !1,
        useIndividualScale: !1
      },
      selectedSerieIndex: null,
      selectedRowIndex: null,
      segregatedSeries: [],
      uniqueId: U(),
      step: 0,
      slicer: s,
      __to__: null,
      maxX: i,
      showSparklineTable: !0,
      segregateStep: 0,
      sliderId: We,
      fontSizes: {
        xAxis: 18,
        yAxis: 12,
        dataLabels: 20,
        plotLabels: 10
      },
      plotRadii: {
        plot: 3,
        line: 3
      },
      selectedMinimapIndex: null
    };
  },
  computed: {
    minimap() {
      if (!this.FINAL_CONFIG.chart.zoom.minimap.show) return [];
      const i = this.datasetWithIds.filter((t) => !this.segregatedSeries.includes(t.id)), s = Math.max(...i.map((t) => t.series.length)), h = [];
      for (let t = 0; t < s; t += 1)
        h.push(i.map((e) => e.series[t] || 0).reduce((e, N) => (e || 0) + (N || 0), 0));
      const f = Math.min(...h);
      return h.map((t) => t + (f < 0 ? Math.abs(f) : 0));
    },
    customPalette() {
      return this.convertCustomPalette(this.FINAL_CONFIG.customPalette);
    },
    backgroundColor() {
      return this.FINAL_CONFIG.chart.backgroundColor;
    },
    slicerColor() {
      return this.FINAL_CONFIG.chart.zoom.color;
    },
    allScales() {
      const i = this.lineSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height,
        autoScaleYLabels: t.autoScaleYLabels
      })), s = this.barSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height
      })), h = this.plotSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        // FIX
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height
      })), f = [...i, ...s, ...h].flatMap((t) => t).length;
      return [...i, ...s, ...h].flatMap((t, e) => ({
        id: t.id,
        scaleLabel: t.scaleLabel,
        name: t.name,
        color: t.color,
        scale: t.scale,
        yOffset: t.yOffset,
        individualHeight: t.individualHeight,
        x: this.mutableConfig.isStacked ? this.drawingArea.left : this.drawingArea.left / f * (e + 1),
        yLabels: t.scaleYLabels || t.scale.ticks.map((N) => ({
          y: N >= 0 ? t.zero - t.individualHeight * (N / t.max) : t.zero + t.individualHeight * Math.abs(N) / t.max,
          value: N
        }))
      }));
    },
    isDataset() {
      return !!this.dataset && this.dataset.length;
    },
    chartFont() {
      const i = document.getElementById(`vue-ui-xy_${this.uniqueId}`);
      return window.getComputedStyle(i, null).getPropertyValue("font-family");
    },
    FINAL_CONFIG: {
      get: function() {
        const i = ae().vue_ui_xy;
        if (!Object.keys(this.config || {}).length)
          return i;
        const s = this.useNestedProp({
          userConfig: this.config,
          defaultConfig: i
        });
        return this.config && this.hasDeepProperty(this.config, "chart.highlightArea") && (Array.isArray(this.config.chart.highlightArea) ? s.chart.highlightArea = this.config.chart.highlightArea : s.chart.highlightArea = [this.config.chart.highlightArea]), this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMin") ? s.chart.grid.labels.yAxis.scaleMin = this.config.chart.grid.labels.yAxis.scaleMin : s.chart.grid.labels.yAxis.scaleMin = null, this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMax") ? s.chart.grid.labels.yAxis.scaleMax = this.config.chart.grid.labels.yAxis.scaleMax : s.chart.grid.labels.yAxis.scaleMax = null, s.theme ? {
          ...Z({
            userConfig: this.themes.vue_ui_xy[s.theme] || this.config,
            defaultConfig: s
          }),
          customPalette: this.themePalettes[s.theme] || this.palette
        } : s;
      },
      set: function(i) {
        return i;
      }
    },
    hasHighlightArea() {
      return Array.isArray(this.FINAL_CONFIG.chart.highlightArea) ? this.FINAL_CONFIG.chart.highlightArea.some((i) => i.show) : this.FINAL_CONFIG.chart.highlightArea && this.FINAL_CONFIG.chart.highlightArea.show;
    },
    highlightAreas() {
      if (Array.isArray(this.FINAL_CONFIG.chart.highlightArea))
        return this.FINAL_CONFIG.chart.highlightArea.map((s) => ({
          ...s,
          span: s.from === s.to ? 1 : s.to < s.from ? 0 : s.to - s.from + 1
        }));
      const i = this.FINAL_CONFIG.chart.highlightArea;
      return [{ ...i, span: i.from === i.to ? 1 : i.to < i.from ? 0 : i.to - i.from + 1 }];
    },
    xPadding() {
      return this.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : this.drawingArea.width / this.maxSeries / 2;
    },
    relativeZero() {
      return this.niceScale.min >= 0 ? 0 : Math.abs(this.niceScale.min);
    },
    absoluteMax() {
      return this.niceScale.max + this.relativeZero;
    },
    datasetWithIds() {
      return this.useSafeValues ? this.dataset.map((i, s) => ({
        ...i,
        id: `uniqueId_${s}`
      })) : this.dataset;
    },
    safeDataset() {
      return this.useSafeValues ? this.dataset.map((i, s) => ({
        ...i,
        series: i.series.map((h) => this.isSafeValue(h) ? h : null).slice(this.slicer.start, this.slicer.end),
        color: this.convertColorToHex(i.color ? i.color : this.customPalette[s] ? this.customPalette[s] : this.palette[s]),
        id: `uniqueId_${s}`
      })) : this.dataset;
    },
    relativeDataset() {
      return this.safeDataset.map((i, s) => ({
        ...i,
        series: i.series.map((h) => h + this.relativeZero),
        absoluteValues: i.series
      })).filter((i) => !this.segregatedSeries.includes(i.id));
    },
    tableSparklineDataset() {
      return this.relativeDataset.map((i) => {
        const s = i.absoluteValues.map((h) => [void 0, null].includes(h) ? 0 : h);
        return {
          id: i.id,
          name: i.name,
          color: i.color,
          values: this.fillArray(this.maxSeries, s)
        };
      });
    },
    tableSparklineConfig() {
      return {
        responsiveBreakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint,
        roundingValues: this.FINAL_CONFIG.table.rounding,
        showAverage: !1,
        showMedian: !1,
        showTotal: !1,
        fontFamily: this.FINAL_CONFIG.chart.fontFamily,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix,
        colNames: JSON.parse(JSON.stringify(this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values)),
        thead: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        tbody: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        userOptions: {
          show: !1
        }
      };
    },
    absoluteDataset() {
      return this.safeDataset.map((i, s) => ({
        absoluteIndex: s,
        ...i,
        series: i.series.map((h) => h + this.relativeZero),
        absoluteValues: i.series,
        segregate: () => this.segregate(i),
        isSegregated: this.segregatedSeries.includes(i.id)
      }));
    },
    barSet() {
      return this.activeSeriesWithStackRatios.filter((i) => i.type === "bar").map((i, s) => {
        this.checkAutoScaleError(i);
        const h = Math.min(...i.absoluteValues.filter((d) => ![null, void 0].includes(d))), f = Math.max(...i.absoluteValues.filter((d) => ![null, void 0].includes(d))), e = {
          ratios: i.absoluteValues.filter((d) => ![null, void 0].includes(d)).map((d) => (d - h) / (f - h)),
          valueMin: h,
          valueMax: f < 0 ? 0 : f
        }, N = {
          max: i.scaleMax || Math.max(...i.absoluteValues) || 1,
          min: i.scaleMin || Math.min(...i.absoluteValues.filter((d) => ![void 0, null].includes(d))) > 0 ? 0 : Math.min(...i.absoluteValues.filter((d) => ![null, void 0].includes(d)))
        }, A = i.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, m = this.calculateNiceScaleWithExactExtremes(N.min, N.max, A), _ = this.calculateNiceScaleWithExactExtremes(e.valueMin, e.valueMax, A), p = m.min >= 0 ? 0 : Math.abs(m.min), k = 0, w = m.max + p, G = _.max + Math.abs(k), x = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - i.cumulatedStackRatio) : 0, C = this.mutableConfig.isStacked ? this.drawingArea.height * i.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, a = this.drawingArea.bottom - x - C * p / w, o = this.drawingArea.bottom - x - C * k / G, n = this.absoluteDataset.filter((d) => d.type === "bar").filter((d) => !this.segregatedSeries.includes(d.id)).length, g = i.series.map((d, F) => {
          const E = this.mutableConfig.useIndividualScale ? (i.absoluteValues[F] + p) / w : this.ratioToMax(d), H = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * F : this.drawingArea.left + this.slot.bar * s + this.slot.bar * F * n - this.barSlot / 2 - s * this.barPeriodGap;
          return {
            yOffset: x,
            individualHeight: C,
            x: H,
            y: this.drawingArea.bottom - x - C * E,
            value: i.absoluteValues[F],
            zeroPosition: a,
            individualMax: w,
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
          };
        }), D = i.absoluteValues.map((d) => _.min >= 0 ? (d - Math.abs(_.min)) / (_.max - Math.abs(_.min)) : (d + Math.abs(_.min)) / (_.max + Math.abs(_.min))), R = i.series.map((d, F) => {
          const E = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * F : this.drawingArea.left - this.slot.bar / 2 + this.slot.bar * s + this.slot.bar * F * this.absoluteDataset.filter((H) => H.type === "bar").filter((H) => !this.segregatedSeries.includes(H.id)).length;
          return {
            yOffset: x,
            individualHeight: C,
            x: E,
            y: this.drawingArea.bottom - x - (C * D[F] || 0),
            value: i.absoluteValues[F],
            zeroPosition: a,
            individualMax: w,
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
          };
        }), y = m.ticks.map((d) => ({
          y: d >= 0 ? a - C * (d / w) : a + C * Math.abs(d) / w,
          value: d
        })), O = _.ticks.map((d) => {
          const F = (d - _.min) / (_.max - _.min);
          return {
            y: d >= 0 ? o - C * F : o + C * F,
            value: d
          };
        });
        return {
          ...i,
          yOffset: x,
          autoScaleYLabels: O,
          individualHeight: C,
          scaleYLabels: i.autoScaling ? O : y,
          individualScale: i.autoScaling ? _ : m,
          individualMax: i.autoScaling ? G : w,
          zeroPosition: i.autoScaling ? o : a,
          plots: i.autoScaling ? R : g
        };
      });
    },
    activeSeriesLength() {
      return this.absoluteDataset.length;
    },
    activeSeriesWithStackRatios() {
      return this.assignStackRatios(this.absoluteDataset.filter((i) => !this.segregatedSeries.includes(i.id)));
    },
    lineSet() {
      return this.activeSeriesWithStackRatios.filter((i) => i.type === "line").map((i) => {
        this.checkAutoScaleError(i);
        const s = Math.min(...i.absoluteValues.filter((d) => ![void 0, null].includes(d))), h = Math.max(...i.absoluteValues.filter((d) => ![void 0, null].includes(d))) || 1, t = {
          ratios: i.absoluteValues.filter((d) => ![null, void 0].includes(d)).map((d) => (d - s) / (h - s)),
          valueMin: s,
          valueMax: h
        }, e = {
          max: i.scaleMax || Math.max(...i.absoluteValues) || 1,
          min: i.scaleMin || (Math.min(...i.absoluteValues) > 0 ? 0 : Math.min(...i.absoluteValues))
        }, N = i.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, A = this.calculateNiceScaleWithExactExtremes(e.min, e.max, N), m = this.calculateNiceScaleWithExactExtremes(t.valueMin, t.valueMax, N), _ = A.min >= 0 ? 0 : Math.abs(A.min), p = 0, k = A.max + Math.abs(_), w = m.max + Math.abs(p), G = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - i.cumulatedStackRatio) : 0, x = this.mutableConfig.isStacked ? this.drawingArea.height * i.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, C = this.drawingArea.bottom - G - x * _ / k, a = this.drawingArea.bottom - G - x * p / w, o = i.series.map((d, F) => {
          const E = this.mutableConfig.useIndividualScale ? (i.absoluteValues[F] + Math.abs(_)) / k : this.ratioToMax(d);
          return {
            x: this.drawingArea.left + this.slot.line / 2 + this.slot.line * F,
            y: this.drawingArea.bottom - G - x * E,
            value: i.absoluteValues[F],
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
          };
        }), n = i.absoluteValues.map((d) => m.min >= 0 ? (d - Math.abs(m.min)) / (m.max - Math.abs(m.min)) : (d + Math.abs(m.min)) / (m.max + Math.abs(m.min))), g = i.series.map((d, F) => {
          if (![void 0, null].includes(i.absoluteValues[F]))
            return {
              x: this.drawingArea.left + this.slot.line / 2 + this.slot.line * F,
              y: this.drawingArea.bottom - G - (x * n[F] || 0),
              value: i.absoluteValues[F],
              comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
            };
        }), D = this.createSmoothPath(o), R = this.createSmoothPath(g), y = A.ticks.map((d) => ({
          y: d >= 0 ? C - x * (d / k) : C + x * Math.abs(d) / k,
          value: d
        })), O = m.ticks.map((d) => {
          const F = (d - m.min) / (m.max - m.min);
          return {
            y: d >= 0 ? a - x * F : a + x * F,
            value: d
          };
        });
        return {
          ...i,
          yOffset: G,
          autoScaleYLabels: O,
          individualHeight: x,
          scaleYLabels: i.autoScaling ? O : y,
          individualScale: i.autoScaling ? m : A,
          individualMax: i.autoScaling ? w : k,
          zeroPosition: i.autoScaling ? a : C,
          curve: i.autoScaling ? R : D,
          plots: i.autoScaling ? g : o,
          area: i.useArea ? this.mutableConfig.useIndividualScale ? this.createIndividualArea(i.autoScaling ? g : o, i.autoScaling ? a : C) : this.createArea(o) : ""
        };
      });
    },
    plotSet() {
      return this.activeSeriesWithStackRatios.filter((i) => i.type === "plot").map((i) => {
        this.checkAutoScaleError(i);
        const s = Math.min(...i.absoluteValues.filter((y) => ![null, void 0].includes(y))), h = Math.max(...i.absoluteValues.filter((y) => ![null, void 0].includes(y))) || 1, t = {
          ratios: i.absoluteValues.filter((y) => ![null, void 0].includes(y)).map((y) => (y - s) / (h - s)),
          valueMin: s,
          valueMax: h
        }, e = {
          max: i.scaleMax || Math.max(...i.absoluteValues) || 1,
          min: i.scaleMin || Math.min(...i.absoluteValues) > 0 ? 0 : Math.min(...i.absoluteValues)
        }, N = i.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, A = this.calculateNiceScaleWithExactExtremes(e.min, e.max, N), m = this.calculateNiceScaleWithExactExtremes(t.valueMin, t.valueMax, N), _ = A.min >= 0 ? 0 : Math.abs(A.min), p = 0, k = A.max + _, w = m.max + Math.abs(p), G = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - i.cumulatedStackRatio) : 0, x = this.mutableConfig.isStacked ? this.drawingArea.height * i.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, C = this.drawingArea.bottom - G - x * _ / k, a = this.drawingArea.bottom - G - x * p / w, o = i.series.map((y, O) => {
          const d = this.mutableConfig.useIndividualScale ? (i.absoluteValues[O] + Math.abs(_)) / k : this.ratioToMax(y);
          return {
            x: this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * O,
            y: this.drawingArea.bottom - G - x * d,
            value: i.absoluteValues[O],
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[O] || ""
          };
        }), n = i.absoluteValues.map((y) => m.min >= 0 ? (y - Math.abs(m.min)) / (m.max - Math.abs(m.min)) : (y + Math.abs(m.min)) / (m.max + Math.abs(m.min))), g = i.series.map((y, O) => ({
          x: this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * O,
          y: this.drawingArea.bottom - G - (x * n[O] || 0),
          value: i.absoluteValues[O],
          comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[O] || ""
        })), D = A.ticks.map((y) => ({
          y: y >= 0 ? C - x * (y / k) : C + x * Math.abs(y) / k,
          value: y
        })), R = m.ticks.map((y) => {
          const O = (y - m.min) / (m.max - m.min);
          return {
            y: y >= 0 ? a - x * O : a + x * O,
            value: y
          };
        });
        return {
          ...i,
          yOffset: G,
          autoScaleYLabels: R,
          individualHeight: x,
          scaleYLabels: i.autoScaling ? R : D,
          individualScale: i.autoScaling ? m : A,
          individualMax: i.autoScaling ? w : k,
          zeroPosition: i.autoScaling ? a : C,
          plots: i.autoScaling ? g : o
        };
      });
    },
    drawingArea() {
      const i = this.mutableConfig.useIndividualScale && this.FINAL_CONFIG.chart.grid.labels.show ? this.absoluteDataset.filter((s) => !this.segregatedSeries.includes(s.id)).length * (this.mutableConfig.isStacked ? 0 : this.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth) : 0;
      return {
        top: this.FINAL_CONFIG.chart.padding.top,
        right: this.width - this.FINAL_CONFIG.chart.padding.right,
        bottom: this.height - this.FINAL_CONFIG.chart.padding.bottom,
        left: this.FINAL_CONFIG.chart.padding.left + i,
        height: this.height - (this.FINAL_CONFIG.chart.padding.top + this.FINAL_CONFIG.chart.padding.bottom),
        width: this.width - (this.FINAL_CONFIG.chart.padding.right + this.FINAL_CONFIG.chart.padding.left + i)
      };
    },
    max() {
      return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax ? this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax : Math.max(...this.safeDataset.filter((i) => !this.segregatedSeries.includes(i.id)).map((i) => Math.max(...i.series)));
    },
    min() {
      if (this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin !== null)
        return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin;
      const i = Math.min(...this.safeDataset.filter((s) => !this.segregatedSeries.includes(s.id)).map((s) => Math.min(...s.series)));
      return i > 0 ? 0 : i;
    },
    niceScale() {
      return this.calculateNiceScaleWithExactExtremes(this.min, this.max < 0 ? 0 : this.max, this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps);
    },
    maxSeries() {
      return this.slicer.end - this.slicer.start;
    },
    timeLabels() {
      return this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values.slice(this.slicer.start, this.slicer.end);
    },
    slot() {
      return {
        bar: this.drawingArea.width / this.maxSeries / this.safeDataset.filter((i) => i.type === "bar").filter((i) => !this.segregatedSeries.includes(i.id)).length,
        plot: this.drawingArea.width / this.maxSeries,
        line: this.drawingArea.width / this.maxSeries
      };
    },
    barSlot() {
      const i = this.safeDataset.filter((s) => s.type === "bar").filter((s) => !this.segregatedSeries.includes(s.id)).length;
      return this.drawingArea.width / this.maxSeries / i - this.barPeriodGap * i;
    },
    barPeriodGap() {
      return this.slot.line * this.FINAL_CONFIG.bar.periodGap;
    },
    maxSlot() {
      return Math.max(...Object.values(this.slot).filter((i) => i !== 1 / 0));
    },
    table() {
      if (this.safeDataset.length === 0) return { head: [], body: [], config: {}, columnNames: [] };
      const i = this.relativeDataset.map((h) => ({
        label: h.name,
        color: h.color,
        type: h.type
      })), s = [];
      return this.timeLabels.forEach((h, f) => {
        const t = [h];
        this.relativeDataset.forEach((e) => {
          t.push(this.canShowValue(e.absoluteValues[f]) ? Number(e.absoluteValues[f].toFixed(this.FINAL_CONFIG.table.rounding)) : "");
        }), s.push(t);
      }), { head: i, body: s };
    },
    dataTable() {
      const i = [""].concat(this.relativeDataset.map((t) => t.name)).concat(' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>');
      let s = [];
      for (let t = 0; t < this.maxSeries; t += 1) {
        const e = this.relativeDataset.map((N) => N.absoluteValues[t] ?? 0).reduce((N, A) => N + A, 0);
        s.push([this.timeLabels[t] ?? "-"].concat(this.relativeDataset.map((N) => (N.absoluteValues[t] ?? 0).toFixed(this.FINAL_CONFIG.table.rounding))).concat((e ?? 0).toFixed(this.FINAL_CONFIG.table.rounding)));
      }
      const h = {
        th: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        td: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        breakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint
      }, f = [this.FINAL_CONFIG.table.columnNames.period].concat(this.relativeDataset.map((t) => t.name)).concat(this.FINAL_CONFIG.table.columnNames.total);
      return { head: i, body: s, config: h, colNames: f };
    },
    dataTooltipSlot() {
      return {
        datapoint: this.selectedSeries,
        seriesIndex: this.selectedSerieIndex,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      };
    },
    selectedSeries() {
      return this.relativeDataset.map((i) => ({
        shape: i.shape || null,
        name: i.name,
        color: i.color,
        type: i.type,
        value: i.absoluteValues.find((s, h) => h === this.selectedSerieIndex),
        comments: i.comments || []
      }));
    },
    tooltipContent() {
      let i = "", s = this.selectedSeries.map((t) => t.value).filter((t) => this.isSafeValue(t) && t !== null).reduce((t, e) => Math.abs(t) + Math.abs(e), 0);
      const h = this.timeLabels[this.selectedSerieIndex], f = this.FINAL_CONFIG.chart.tooltip.customFormat;
      return this.isFunction(f) && this.functionReturnsString(() => f({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      })) ? f({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      }) : (h && (i += `<div style="padding-bottom: 6px; margin-bottom: 4px; border-bottom: 1px solid ${this.FINAL_CONFIG.chart.tooltip.borderColor}; width:100%">${h}</div>`), this.selectedSeries.forEach((t) => {
        if (this.isSafeValue(t.value)) {
          let e = "", N = "";
          switch (this.icons[t.type]) {
            case "bar":
              e = `<svg viewBox="0 0 12 12" height="14" width="14"><rect x="0" y="0" rx="1" stroke="none" height="12" width="12" fill="${t.color}" /></svg>`;
              break;
            case "line":
              !t.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(t.shape) ? N = `<circle cx="10" cy="8" r="4" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" />` : t.shape === "triangle" ? N = `<path d="${P({ plot: { x: 10, y: 8 }, radius: 4, sides: 3, rotation: 0.52 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : t.shape === "square" ? N = `<path d="${P({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0.8 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : t.shape === "diamond" ? N = `<path d="${P({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : t.shape === "pentagon" ? N = `<path d="${P({ plot: { x: 10, y: 8 }, radius: 4, sides: 5, rotation: 0.95 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : t.shape === "hexagon" ? N = `<path d="${P({ plot: { x: 10, y: 8 }, radius: 4, sides: 6, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : t.shape === "star" && (N = `<polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" points="${X({ plot: { x: 10, y: 8 }, radius: 4 })}" />`), e = `<svg viewBox="0 0 20 12" height="14" width="20"><rect rx="3" x="0" y="6" stroke="none" height="4" width="20" fill="${t.color}" />${N}</svg>`;
              break;
            case "plot":
              if (!t.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(t.shape)) {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" /></svg>`;
                break;
              }
              if (t.shape === "star") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" points="${X({ plot: { x: 6, y: 6 }, radius: 5 })}" /></svg>`;
                break;
              }
              if (t.shape === "triangle") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${P({ plot: { x: 6, y: 6 }, radius: 6, sides: 3, rotation: 0.52 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "square") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${P({ plot: { x: 6, y: 6 }, radius: 6, sides: 4, rotation: 0.8 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "diamond") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${P({ plot: { x: 6, y: 6 }, radius: 5, sides: 4, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "pentagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${P({ plot: { x: 6, y: 6 }, radius: 5, sides: 5, rotation: 0.95 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "hexagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${P({ plot: { x: 6, y: 6 }, radius: 5, sides: 6, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
          }
          i += `<div style="display:flex;flex-direction:row; align-items:center;gap:3px;"><div style="width:20px">${e}</div> ${t.name}: <b>${this.FINAL_CONFIG.chart.tooltip.showValue ? this.applyDataLabel(
            t.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : t.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
            t.value,
            this.dataLabel({
              p: this.FINAL_CONFIG.chart.labels.prefix,
              v: t.value,
              s: this.FINAL_CONFIG.chart.labels.suffix,
              r: this.FINAL_CONFIG.chart.tooltip.roundingValue
            }),
            { datapoint: t }
          ) : ""}</b> ${this.FINAL_CONFIG.chart.tooltip.showPercentage ? `(${q({
            v: this.checkNaN(Math.abs(t.value) / s * 100),
            s: "%",
            r: this.FINAL_CONFIG.chart.tooltip.roundingPercentage
          })})` : ""}</div>`, this.FINAL_CONFIG.chart.comments.showInTooltip && t.comments.length && t.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex] && (i += `<div class="vue-data-ui-tooltip-comment" style="background:${t.color}20; padding: 6px; margin-bottom: 6px; border-left: 1px solid ${t.color}">${t.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex]}</div>`);
        }
      }), `<div style="border-radius:4px;padding:12px;font-variant-numeric: tabular-nums;color:${this.FINAL_CONFIG.chart.tooltip.color}">${i}</div>`);
    },
    svg() {
      return {
        height: this.height,
        width: this.width
      };
    },
    yLabels() {
      return this.niceScale.ticks.map((i) => ({
        y: i >= 0 ? this.zero - this.drawingArea.height * this.ratioToMax(i) : this.zero + this.drawingArea.height * this.ratioToMax(Math.abs(i)),
        value: i
      }));
    },
    zero() {
      return this.drawingArea.bottom - this.drawingArea.height * this.ratioToMax(this.relativeZero);
    }
  },
  mounted() {
    if (this.objectIsEmpty(this.dataset) ? this.error({
      componentName: "VueUiXy",
      type: "dataset"
    }) : this.dataset.forEach((i, s) => {
      [null, void 0].includes(i.name) && this.error({
        componentName: "VueUiXy",
        type: "datasetSerieAttribute",
        property: "name (string)",
        index: s
      });
    }), this.FINAL_CONFIG.showWarnings && this.dataset.forEach((i) => {
      i.series.forEach((s, h) => {
        this.isSafeValue(s) || console.warn(`VueUiXy has detected an unsafe value in your dataset:
-----> The serie '${i.name}' contains the value '${s}' at index ${h}.
'${s}' was converted to null to allow the chart to display.`);
      });
    }), document.addEventListener("mousemove", (i) => {
      this.clientPosition = {
        x: i.clientX,
        y: i.clientY
      };
    }), this.mutableConfig = {
      dataLabels: {
        show: !0
      },
      showTooltip: this.FINAL_CONFIG.chart.tooltip.show === !0,
      showTable: this.FINAL_CONFIG.showTable === !0,
      isStacked: this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked,
      useIndividualScale: this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale
    }, this.FINAL_CONFIG.responsive) {
      const s = this.$refs.chart.parentNode, { height: h, width: f } = s.getBoundingClientRect();
      let t = null, e = 0;
      this.FINAL_CONFIG.chart.title.show && (t = this.$refs.chartTitle, e = t.getBoundingClientRect().height);
      let N = null, A = 0;
      this.FINAL_CONFIG.chart.zoom.show && this.maxX > 6 && this.isDataset && (N = this.$refs.chartSlicer.$el, A = N.getBoundingClientRect().height);
      let m = null, _ = 0;
      this.FINAL_CONFIG.chart.legend.show && (m = this.$refs.chartLegend, _ = m.getBoundingClientRect().height), this.height = h - e - _ - A, this.width = f, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes(), new ResizeObserver((k) => {
        for (const w of k)
          this.$refs.chartTitle && (e = this.$refs.chartTitle.getBoundingClientRect().height), this.$refs.chartSlicer && this.$refs.chartSlicer.$el && (A = this.$refs.chartSlicer.$el.getBoundingClientRect().height), this.$refs.chartLegend && (_ = this.$refs.chartLegend.getBoundingClientRect().height), this.height = w.contentBoxSize[0].blockSize - e - _ - A - 24, this.width = w.contentBoxSize[0].inlineSize, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes();
      }).observe(s);
    } else
      this.height = this.FINAL_CONFIG.chart.height, this.width = this.FINAL_CONFIG.chart.width, this.viewBox = `0 0 ${this.width} ${this.height}`, this.fontSizes.dataLabels = this.FINAL_CONFIG.chart.grid.labels.fontSize, this.fontSizes.yAxis = this.FINAL_CONFIG.chart.grid.labels.axis.fontSize, this.fontSizes.xAxis = this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize, this.fontSizes.plotLabels = this.FINAL_CONFIG.chart.labels.fontSize, this.plotRadii.plot = this.FINAL_CONFIG.plot.radius, this.plotRadii.line = this.FINAL_CONFIG.line.radius;
  },
  methods: {
    abbreviate: ie,
    adaptColorToBackground: le,
    applyDataLabel: re,
    assignStackRatios: se,
    calcLinearProgression: ne,
    calculateNiceScaleWithExactExtremes: oe,
    checkNaN: ce,
    closestDecimal: he,
    convertColorToHex: de,
    convertConfigColors: ue,
    convertCustomPalette: ge,
    createCsvContent: fe,
    createSmoothPath: me,
    createTSpans: Ie,
    dataLabel: q,
    downloadCsv: be,
    error: Ne,
    functionReturnsString: xe,
    hasDeepProperty: _e,
    img: Q,
    isFunction: Fe,
    isSafeValue: ye,
    objectIsEmpty: Ae,
    pdf: J,
    shiftHue: Le,
    translateSize: Ce,
    treeShake: Se,
    useMouse: ve,
    useNestedProp: Z,
    selectMinimapIndex(i) {
      this.selectedMinimapIndex = i;
    },
    convertSizes() {
      this.fontSizes.dataLabels = this.translateSize({
        relator: this.height,
        adjuster: 400,
        source: this.FINAL_CONFIG.chart.grid.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.yAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.axis.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.xAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.plotLabels = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.chart.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.plotRadii.plot = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.plot.radius,
        threshold: 1,
        fallback: 1
      }), this.plotRadii.line = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.line.radius,
        threshold: 1,
        fallback: 1
      });
    },
    toggleStack() {
      this.mutableConfig.isStacked = !this.mutableConfig.isStacked, this.mutableConfig.isStacked ? this.mutableConfig.useIndividualScale = !0 : this.mutableConfig.useIndividualScale = this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale;
    },
    toggleTable() {
      this.mutableConfig.showTable = !this.mutableConfig.showTable;
    },
    toggleLabels() {
      this.mutableConfig.dataLabels.show = !this.mutableConfig.dataLabels.show;
    },
    toggleTooltip() {
      this.mutableConfig.showTooltip = !this.mutableConfig.showTooltip;
    },
    checkAutoScaleError(i) {
      i.autoScaling && (this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale || console.warn(`VueUiXy (datapoint: ${i.name}) : autoScaling only works when config.chart.grid.labels.yAxis.useIndividualScale is set to true`), this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked || console.warn(`VueUiXy (datapoint: ${i.name}) : autoScaling only works when config.chart.grid.labels.yAxis.stacked is set to true`));
    },
    createArea(i) {
      if (!i[0]) return [-10, -10, "", -10, -10];
      const s = { x: i[0].x, y: this.zero }, h = { x: i.at(-1).x, y: this.zero }, f = [];
      return i.forEach((t) => {
        f.push(`${t.x},${t.y} `);
      }), [s.x, s.y, ...f, h.x, h.y].toString();
    },
    createIndividualArea(i, s) {
      if (!i[0]) return [-10, -10, "", -10, -10];
      const h = { x: i[0] ? i[0].x : Math.min(...i.filter((e) => !!e).map((e) => e.x)), y: s }, f = { x: i.at(-1) ? i.at(-1).x : Math.min(...i.filter((e) => !!e).map((e) => e.x)), y: s }, t = [];
      return i.filter((e) => !!e).forEach((e) => {
        t.push(`${e.x},${e.y} `);
      }), [h.x, h.y, ...t, f.x, f.y].toString();
    },
    createStar: X,
    createPolygonPath: P,
    fillArray(i, s) {
      let h = Array(i).fill(0);
      for (let f = 0; f < s.length && f < i; f += 1)
        h[f] = s[f];
      return h;
    },
    refreshSlicer() {
      this.slicer = {
        start: 0,
        end: Math.max(...this.dataset.map((i) => i.series.length))
      }, this.slicerStep += 1;
    },
    calcRectHeight(i) {
      return i.value >= 0 ? this.zero - i.y <= 0 ? 1e-5 : this.zero - i.y : i.y - this.zero <= 0 ? 1e-5 : i.y - this.zero;
    },
    calcIndividualHeight(i) {
      return i.value >= 0 ? i.zeroPosition - i.y <= 0 ? 1e-5 : i.zeroPosition - i.y : i.y - i.zeroPosition <= 0 ? 1e-5 : i.zeroPosition - i.y;
    },
    calcRectWidth() {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.slot.line - this.drawingArea.width / this.maxSeries * 0.1 : this.slot.bar;
    },
    calcRectX(i) {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? i.x + this.drawingArea.width / this.maxSeries * 0.05 : i.x + this.slot.bar / 2;
    },
    calcRectY(i) {
      return i.value >= 0 ? i.y : this.zero;
    },
    calcIndividualRectY(i) {
      return i.value >= 0 ? i.y : i.zeroPosition;
    },
    canShowValue(i) {
      return ![null, void 0, NaN].includes(i);
    },
    findClosestValue(i, s) {
      let h = s[0], f = Math.abs(i - s[0]);
      for (let t = 1; t < s.length; t += 1) {
        const e = Math.abs(i - s[t]);
        e < f && s[t] < i && (h = s[t], f = e);
      }
      return h;
    },
    ratioToMax(i) {
      return i / this.absoluteMax;
    },
    selectX(i) {
      this.$emit(
        "selectX",
        {
          dataset: this.relativeDataset.map((s) => ({
            name: s.name,
            value: [null, void 0, NaN].includes(s.absoluteValues[i]) ? null : s.absoluteValues[i],
            color: s.color,
            type: s.type
          })),
          index: i,
          indexLabel: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[i]
        }
      );
    },
    getData() {
      return this.absoluteDataset.map((i) => ({
        values: i.absoluteValues,
        color: i.color,
        name: i.name,
        type: i.type
      }));
    },
    segregate(i) {
      if (this.segregatedSeries.includes(i.id))
        this.segregatedSeries = this.segregatedSeries.filter((s) => s !== i.id);
      else {
        if (this.segregatedSeries.length + 1 === this.safeDataset.length) return;
        this.segregatedSeries.push(i.id);
      }
      this.$emit("selectLegend", this.relativeDataset.map((s) => ({
        name: s.name,
        values: s.absoluteValues,
        color: s.color,
        type: s.type
      }))), this.segregateStep += 1;
    },
    toggleTooltipVisibility(i, s = null) {
      this.isTooltip = i, i ? this.selectedSerieIndex = s : this.selectedSerieIndex = null;
    },
    toggleFullscreen(i) {
      this.isFullscreen = i, this.step += 1;
    },
    showSpinnerPdf() {
      this.isPrinting = !0;
    },
    generatePdf() {
      this.showSpinnerPdf(), clearTimeout(this.__to__), this.__to__ = setTimeout(() => {
        this.pdf({
          domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
          fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy"
        }).finally(() => {
          this.isPrinting = !1;
        });
      }, 100);
    },
    generateCsv() {
      const i = [[this.FINAL_CONFIG.chart.title.text], [this.FINAL_CONFIG.chart.title.subtitle.text], [""]], s = ["", ...this.table.head.map((e) => e.label)], h = this.table.body, f = i.concat([s]).concat(h), t = this.createCsvContent(f);
      this.downloadCsv({ csvContent: t, title: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy" });
    },
    showSpinnerImage() {
      this.isImaging = !0;
    },
    generateImage() {
      this.showSpinnerImage(), clearTimeout(this.__to__), this.__to__ = setTimeout(() => {
        this.img({
          domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
          fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy",
          format: "png"
        }).finally(() => {
          this.isImaging = !1;
        });
      }, 100);
    }
  }
}, Ye = ["id"], Xe = ["viewBox"], qe = { key: 0 }, Ze = { class: "vue-ui-xy-grid" }, Ue = ["stroke", "x1", "x2", "y1", "y2"], Je = ["stroke", "x1", "x2", "y1", "y2"], Ke = { key: 1 }, Qe = ["x1", "x2", "y1", "y2", "stroke"], je = ["x1", "x2", "y1", "y2", "stroke"], $e = ["x1", "x2", "y1", "y2", "stroke"], et = { key: 3 }, tt = ["x1", "x2", "y1", "y2", "stroke"], at = ["id"], it = ["stop-color"], lt = ["stop-color"], rt = ["stop-color"], st = ["id"], nt = ["stop-color"], ot = ["stop-color"], ct = ["stop-color"], ht = ["id"], dt = ["stop-color"], ut = ["stop-color"], gt = ["id"], ft = ["stop-color"], mt = ["stop-color"], It = ["id"], bt = ["stop-color"], Nt = ["stop-color"], xt = ["x", "y", "height", "width", "fill"], _t = ["x", "y", "width"], Ft = ["x", "y", "height", "width", "fill"], yt = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], At = ["width", "x", "y"], Lt = { key: 0 }, Ct = ["id"], St = ["fill"], kt = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], wt = ["x", "y", "font-size", "fill"], Ot = ["stroke", "x1", "x2", "y1", "y2"], vt = { key: 2 }, Gt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], zt = ["y", "width", "height", "fill"], pt = ["x", "y", "width", "height", "fill"], Mt = ["x", "y", "width", "height", "stroke", "stroke-width", "stroke-linecap", "stroke-linejoin", "stroke-dasharray"], Pt = { key: 4 }, Tt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Vt = ["fill", "font-size", "transform"], Rt = ["x1", "x2", "y1", "y2", "stroke"], Dt = ["x", "y", "font-size", "fill"], Et = ["x1", "x2", "y1", "y2", "stroke"], Ht = ["x", "y", "font-size", "fill"], Wt = ["width", "x", "y"], Bt = { style: { width: "100%" } }, Yt = { key: 0 }, Xt = ["id"], qt = ["fill"], Zt = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], Ut = ["x", "y", "font-size", "fill"], Jt = ["d", "stroke", "stroke-width", "stroke-dasharray"], Kt = { key: 1 }, Qt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], jt = { key: 0 }, $t = ["d", "fill"], ea = ["d", "fill"], ta = ["d", "stroke", "stroke-width", "stroke-dasharray"], aa = { key: 2 }, ia = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], la = ["width", "x", "y"], ra = { style: { width: "100%" } }, sa = { key: 3 }, na = ["id"], oa = ["fill"], ca = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], ha = ["x", "y", "font-size", "fill"], da = { key: 5 }, ua = ["x", "y", "font-size", "fill"], ga = ["x", "y", "font-size", "fill", "font-weight"], fa = { key: 6 }, ma = ["x", "y", "font-size", "fill"], Ia = ["x", "y"], ba = ["x", "y"], Na = { key: 7 }, xa = ["x", "y", "font-size", "fill"], _a = ["x", "y"], Fa = ["x", "y"], ya = ["x", "y", "font-size", "fill", "innerHTML"], Aa = ["x", "y", "font-size", "fill", "innerHTML"], La = ["x", "y", "font-size", "fill", "innerHTML"], Ca = ["x", "y", "font-size", "fill", "innerHTML"], Sa = ["x", "y", "width", "height", "fill", "onMouseenter"], ka = ["font-size", "fill", "transform"], wa = ["x", "y", "font-size", "fill"], Oa = { key: 9 }, va = ["text-anchor", "font-size", "fill", "transform"], Ga = ["x", "y", "height", "width", "onMouseenter", "onClick"], za = { key: 10 }, pa = ["x", "y"], Ma = ["cx", "cy", "r", "fill"], Pa = {
  key: 3,
  class: "vue-data-ui-watermark"
}, Ta = ["onClick"], Va = {
  key: 0,
  viewBox: "0 0 20 12",
  height: "14",
  width: "20"
}, Ra = ["fill"], Da = {
  key: 1,
  viewBox: "0 0 12 12",
  height: "14",
  width: "14"
}, Ea = ["fill"], Ha = {
  key: 7,
  ref: "chartLegend"
}, Wa = {
  style: { display: "flex", "flex-direction": "row", gap: "6px", "align-items": "center", "padding-left": "6px" },
  "data-html2canvas-ignore": ""
}, Ba = ["innerHTML"];
function Ya(i, s, h, f, t, e) {
  const N = T("Title"), A = T("UserOptions"), m = T("Shape"), _ = T("Skeleton"), p = T("Slicer"), k = T("Tooltip"), w = T("BaseIcon"), G = T("TableSparkline"), x = T("DataTable"), C = T("Accordion");
  return l(), r("div", {
    id: `vue-ui-xy_${t.uniqueId}`,
    class: M(`vue-ui-xy ${t.isFullscreen ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.FINAL_CONFIG.useCssAnimation ? "" : "vue-ui-dna"}`),
    ref: "chart",
    style: L(`background:${e.FINAL_CONFIG.chart.backgroundColor}; color:${e.FINAL_CONFIG.chart.color};width:100%;${e.FINAL_CONFIG.chart.title.text ? "" : "padding-top:36px"};font-family:${e.FINAL_CONFIG.chart.fontFamily};${e.FINAL_CONFIG.responsive ? "height: 100%" : ""}`)
  }, [
    e.FINAL_CONFIG.chart.title.show ? (l(), r("div", {
      key: 0,
      ref: "chartTitle",
      class: "vue-ui-xy-title",
      style: L(`font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      Y(N, {
        config: {
          title: {
            cy: "xy-div-title",
            ...e.FINAL_CONFIG.chart.title
          },
          subtitle: {
            cy: "xy-div-subtitle",
            ...e.FINAL_CONFIG.chart.title.subtitle
          }
        }
      }, null, 8, ["config"])
    ], 4)) : c("", !0),
    e.FINAL_CONFIG.chart.userOptions.show && e.isDataset ? (l(), V(A, {
      ref: "defails",
      key: `user_options_${t.step}`,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      isPrinting: t.isPrinting,
      isImaging: t.isImaging,
      uid: t.uniqueId,
      hasTooltip: e.FINAL_CONFIG.chart.userOptions.buttons.tooltip && e.FINAL_CONFIG.chart.tooltip.show,
      hasPdf: e.FINAL_CONFIG.chart.userOptions.buttons.pdf,
      hasXls: e.FINAL_CONFIG.chart.userOptions.buttons.csv,
      hasImg: e.FINAL_CONFIG.chart.userOptions.buttons.img,
      hasLabel: e.FINAL_CONFIG.chart.userOptions.buttons.labels,
      hasTable: e.FINAL_CONFIG.chart.userOptions.buttons.table,
      hasStack: h.dataset.length > 1 && e.FINAL_CONFIG.chart.userOptions.buttons.stack,
      hasFullscreen: e.FINAL_CONFIG.chart.userOptions.buttons.fullscreen,
      isStacked: t.mutableConfig.isStacked,
      isFullscreen: t.isFullscreen,
      chartElement: i.$refs.chart,
      isTooltip: t.mutableConfig.showTooltip,
      titles: { ...e.FINAL_CONFIG.chart.userOptions.buttonTitles },
      onToggleFullscreen: e.toggleFullscreen,
      onGeneratePdf: e.generatePdf,
      onGenerateCsv: e.generateCsv,
      onGenerateImage: e.generateImage,
      onToggleTable: e.toggleTable,
      onToggleLabels: e.toggleLabels,
      onToggleStack: e.toggleStack,
      onToggleTooltip: e.toggleTooltip
    }, Ve({ _: 2 }, [
      i.$slots.optionTooltip ? {
        name: "optionTooltip",
        fn: z(() => [
          v(i.$slots, "optionTooltip", {}, void 0, !0)
        ]),
        key: "0"
      } : void 0,
      i.$slots.optionPdf ? {
        name: "optionPdf",
        fn: z(() => [
          v(i.$slots, "optionPdf", {}, void 0, !0)
        ]),
        key: "1"
      } : void 0,
      i.$slots.optionCsv ? {
        name: "optionCsv",
        fn: z(() => [
          v(i.$slots, "optionCsv", {}, void 0, !0)
        ]),
        key: "2"
      } : void 0,
      i.$slots.optionImg ? {
        name: "optionImg",
        fn: z(() => [
          v(i.$slots, "optionImg", {}, void 0, !0)
        ]),
        key: "3"
      } : void 0,
      i.$slots.optionTable ? {
        name: "optionTable",
        fn: z(() => [
          v(i.$slots, "optionTable", {}, void 0, !0)
        ]),
        key: "4"
      } : void 0,
      i.$slots.optionLabels ? {
        name: "optionLabels",
        fn: z(() => [
          v(i.$slots, "optionLabels", {}, void 0, !0)
        ]),
        key: "5"
      } : void 0,
      i.$slots.optionStack ? {
        name: "optionStack",
        fn: z(() => [
          v(i.$slots, "optionStack", {}, void 0, !0)
        ]),
        key: "6"
      } : void 0,
      i.$slots.optionFullscreen ? {
        name: "optionFullscreen",
        fn: z(({ toggleFullscreen: a, isFullscreen: o }) => [
          v(i.$slots, "optionFullscreen", W(B({ toggleFullscreen: a, isFullscreen: o })), void 0, !0)
        ]),
        key: "7"
      } : void 0
    ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasLabel", "hasTable", "hasStack", "hasFullscreen", "isStacked", "isFullscreen", "chartElement", "isTooltip", "titles", "onToggleFullscreen", "onGeneratePdf", "onGenerateCsv", "onGenerateImage", "onToggleTable", "onToggleLabels", "onToggleStack", "onToggleTooltip"])) : c("", !0),
    e.isDataset ? (l(), r("svg", {
      key: 2,
      xmlns: "http://www.w3.org/2000/svg",
      class: M([{ "vue-data-ui-fullscreen--on": t.isFullscreen, "vue-data-ui-fulscreen--off": !t.isFullscreen }, "vue-ui-xy-svg"]),
      width: "100%",
      viewBox: t.viewBox,
      style: L(`background:${e.FINAL_CONFIG.chart.backgroundColor}; color:${e.FINAL_CONFIG.chart.color}; font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      e.maxSeries > 0 ? (l(), r("g", qe, [
        u("g", Ze, [
          e.FINAL_CONFIG.chart.grid.labels.xAxis.showBaseline ? (l(), r("line", {
            key: 0,
            stroke: e.FINAL_CONFIG.chart.grid.stroke,
            "stroke-width": "1",
            x1: e.drawingArea.left + e.xPadding,
            x2: e.drawingArea.right - e.xPadding,
            y1: e.drawingArea.bottom,
            y2: e.drawingArea.bottom,
            "stroke-linecap": "round"
          }, null, 8, Ue)) : c("", !0),
          t.mutableConfig.useIndividualScale ? e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (l(!0), r(I, { key: 2 }, b(e.allScales, (a) => (l(), r("g", null, [
            a.id === t.selectedScale && a.yLabels.length ? (l(!0), r(I, { key: 0 }, b(a.yLabels, (o) => (l(), r("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: o.y,
              y2: o.y,
              stroke: a.color,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, je))), 256)) : a.yLabels.length ? (l(!0), r(I, { key: 1 }, b(a.yLabels, (o) => (l(), r("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: o.y,
              y2: o.y,
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, $e))), 256)) : c("", !0)
          ]))), 256)) : c("", !0) : (l(), r(I, { key: 1 }, [
            e.FINAL_CONFIG.chart.grid.labels.yAxis.showBaseline ? (l(), r("line", {
              key: 0,
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left + e.xPadding,
              y1: e.drawingArea.top,
              y2: e.drawingArea.bottom,
              "stroke-linecap": "round"
            }, null, 8, Je)) : c("", !0),
            e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (l(), r("g", Ke, [
              (l(!0), r(I, null, b(e.yLabels, (a) => (l(), r("line", {
                x1: e.drawingArea.left + e.xPadding,
                x2: e.drawingArea.right - e.xPadding,
                y1: a.y,
                y2: a.y,
                stroke: e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-width": 0.5,
                "stroke-linecap": "round"
              }, null, 8, Qe))), 256))
            ])) : c("", !0)
          ], 64)),
          e.FINAL_CONFIG.chart.grid.showVerticalLines ? (l(), r("g", et, [
            (l(!0), r(I, null, b(e.maxSeries + (e.FINAL_CONFIG.chart.grid.position === "middle" ? 1 : 0), (a, o) => (l(), r("line", {
              key: `grid_vertical_line_${o}`,
              x1: e.drawingArea.width / e.maxSeries * o + e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.width / e.maxSeries * o + e.drawingArea.left + e.xPadding,
              y1: e.drawingArea.top,
              y2: e.drawingArea.bottom,
              "stroke-width": "0.5",
              stroke: e.FINAL_CONFIG.chart.grid.stroke
            }, null, 8, tt))), 128))
          ])) : c("", !0)
        ]),
        (l(!0), r(I, null, b(e.barSet, (a, o) => (l(), r("defs", {
          key: `def_rect_${o}`
        }, [
          u("linearGradient", {
            id: `rectGradient_pos_${o}_${t.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": a.color
            }, null, 8, it),
            u("stop", {
              offset: "62%",
              "stop-color": `${e.shiftHue(a.color, 0.02)}DE`
            }, null, 8, lt),
            u("stop", {
              offset: "100%",
              "stop-color": `${e.shiftHue(a.color, 0.05)}66`
            }, null, 8, rt)
          ], 8, at),
          u("linearGradient", {
            id: `rectGradient_neg_${o}_${t.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(a.color, 0.05)}66`
            }, null, 8, nt),
            u("stop", {
              offset: "38%",
              "stop-color": `${e.shiftHue(a.color, 0.02)}DE`
            }, null, 8, ot),
            u("stop", {
              offset: "100%",
              "stop-color": a.color
            }, null, 8, ct)
          ], 8, st)
        ]))), 128)),
        (l(!0), r(I, null, b(e.plotSet, (a, o) => (l(), r("defs", {
          key: `def_plot_${o}`
        }, [
          u("radialGradient", {
            id: `plotGradient_${o}_${t.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(a.color, 0.05)}`
            }, null, 8, dt),
            u("stop", {
              offset: "100%",
              "stop-color": a.color
            }, null, 8, ut)
          ], 8, ht)
        ]))), 128)),
        (l(!0), r(I, null, b(e.lineSet, (a, o) => (l(), r("defs", {
          key: `def_line_${o}`
        }, [
          u("radialGradient", {
            id: `lineGradient_${o}_${t.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(a.color, 0.05)}`
            }, null, 8, ft),
            u("stop", {
              offset: "100%",
              "stop-color": a.color
            }, null, 8, mt)
          ], 8, gt),
          u("linearGradient", {
            id: `areaGradient_${o}_${t.uniqueId}`,
            x1: "0%",
            x2: "100%",
            y1: "0%",
            y2: "0%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(a.color, 0.03)}${t.opacity[e.FINAL_CONFIG.line.area.opacity]}`
            }, null, 8, bt),
            u("stop", {
              offset: "100%",
              "stop-color": `${a.color}${t.opacity[e.FINAL_CONFIG.line.area.opacity]}`
            }, null, 8, Nt)
          ], 8, It)
        ]))), 128)),
        (l(!0), r(I, null, b(e.highlightAreas, (a) => (l(), r("g", null, [
          a.show ? (l(), r(I, { key: 0 }, [
            u("rect", {
              style: { transition: "none" },
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (a.from - t.slicer.start),
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries * a.span < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries * a.span,
              fill: `${a.color}${t.opacity[a.opacity]}`
            }, null, 8, xt),
            a.caption.text ? (l(), r("foreignObject", {
              key: 0,
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (a.from - t.slicer.start) - (a.caption.width === "auto" ? 0 : a.caption.width / 2 - e.drawingArea.width / e.maxSeries * a.span / 2),
              y: e.drawingArea.top + a.caption.offsetY,
              style: { overflow: "visible" },
              height: "1",
              width: a.caption.width === "auto" ? e.drawingArea.width / e.maxSeries * a.span : a.caption.width
            }, [
              u("div", {
                style: L(`padding:${a.caption.padding}px;text-align:${a.caption.textAlign};font-size:${a.caption.fontSize}px;color:${a.caption.color};font-weight:${a.caption.bold ? "bold" : "normal"}`)
              }, S(a.caption.text), 5)
            ], 8, _t)) : c("", !0)
          ], 64)) : c("", !0)
        ]))), 256)),
        u("g", null, [
          (l(!0), r(I, null, b(e.maxSeries, (a, o) => (l(), r("g", {
            key: `tooltip_trap_${o}`
          }, [
            u("rect", {
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * o,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: [t.selectedMinimapIndex, t.selectedSerieIndex, t.selectedRowIndex].includes(o) ? `${e.FINAL_CONFIG.chart.highlighter.color}${t.opacity[e.FINAL_CONFIG.chart.highlighter.opacity]}` : "transparent"
            }, null, 8, Ft)
          ]))), 128))
        ]),
        e.barSet.length ? (l(!0), r(I, { key: 0 }, b(e.barSet, (a, o) => (l(), r("g", {
          key: `serie_bar_${o}`,
          class: M(`serie_bar_${o}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (l(!0), r(I, null, b(a.plots, (n, g) => (l(), r("g", {
            key: `bar_plot_${o}_${g}`
          }, [
            e.canShowValue(n.value) ? (l(), r("rect", {
              key: 0,
              x: e.calcRectX(n),
              y: t.mutableConfig.useIndividualScale ? e.calcIndividualRectY(n) : e.calcRectY(n),
              height: t.mutableConfig.useIndividualScale ? Math.abs(e.calcIndividualHeight(n)) : Math.abs(e.calcRectHeight(n)),
              width: e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap),
              rx: e.FINAL_CONFIG.bar.borderRadius,
              fill: e.FINAL_CONFIG.bar.useGradient ? n.value >= 0 ? `url(#rectGradient_pos_${o}_${t.uniqueId})` : `url(#rectGradient_neg_${o}_${t.uniqueId})` : a.color,
              stroke: e.FINAL_CONFIG.bar.border.useSerieColor ? a.color : e.FINAL_CONFIG.bar.border.stroke,
              "stroke-width": e.FINAL_CONFIG.bar.border.strokeWidth
            }, null, 8, yt)) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (l(), r("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: (e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) / 2) + e.FINAL_CONFIG.chart.comments.width,
              x: e.calcRectX(n) - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              v(i.$slots, "plot-comment", {
                plot: { ...n, color: a.color }
              }, void 0, !0)
            ], 8, At)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(a, "useProgression") && a.useProgression === !0 && !isNaN(e.calcLinearProgression(a.plots).trend) ? (l(), r("g", Lt, [
            u("defs", null, [
              u("marker", {
                id: `bar_arrow_${o}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                u("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: a.color
                }, null, 8, St)
              ], 8, Ct)
            ]),
            a.plots.length > 1 ? (l(), r("line", {
              key: 0,
              x1: e.calcLinearProgression(a.plots).x1,
              x2: e.calcLinearProgression(a.plots).x2,
              y1: e.calcLinearProgression(a.plots).y1,
              y2: e.calcLinearProgression(a.plots).y2,
              "stroke-width": 1,
              stroke: a.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#bar_arrow_${o})`
            }, null, 8, kt)) : c("", !0),
            a.plots.length > 1 ? (l(), r("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(a.plots).x2,
              y: e.calcLinearProgression(a.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: a.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(a.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, wt)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)) : c("", !0),
        !t.mutableConfig.useIndividualScale && e.FINAL_CONFIG.chart.grid.labels.zeroLine.show ? (l(), r("line", {
          key: 1,
          stroke: e.FINAL_CONFIG.chart.grid.stroke,
          "stroke-width": "1",
          x1: e.drawingArea.left + e.xPadding,
          x2: e.drawingArea.right - e.xPadding,
          y1: e.checkNaN(e.zero),
          y2: e.checkNaN(e.zero),
          "stroke-linecap": "round"
        }, null, 8, Ot)) : c("", !0),
        e.FINAL_CONFIG.chart.highlighter.useLine && (![null, void 0].includes(t.selectedSerieIndex) || t.selectedMinimapIndex !== null) ? (l(), r("g", vt, [
          u("line", {
            x1: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (t.selectedSerieIndex || t.selectedMinimapIndex) + e.drawingArea.width / e.maxSeries / 2,
            x2: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (t.selectedSerieIndex || t.selectedMinimapIndex) + e.drawingArea.width / e.maxSeries / 2,
            y1: e.drawingArea.top,
            y2: e.drawingArea.bottom,
            stroke: e.FINAL_CONFIG.chart.highlighter.color,
            "stroke-width": e.FINAL_CONFIG.chart.highlighter.lineWidth,
            "stroke-dasharray": e.FINAL_CONFIG.chart.highlighter.lineDasharray,
            "stroke-linecap": "round",
            style: { transition: "none !important", animation: "none !important", "pointer-events": "none" }
          }, null, 8, Gt)
        ])) : c("", !0),
        u("g", null, [
          u("rect", {
            style: { transition: "none" },
            x: 0,
            y: e.drawingArea.top,
            width: e.FINAL_CONFIG.chart.padding.left - 1 + e.xPadding,
            height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
            fill: e.FINAL_CONFIG.chart.backgroundColor
          }, null, 8, zt),
          u("rect", {
            style: { transition: "none" },
            x: e.drawingArea.right + 1 - e.xPadding,
            y: e.drawingArea.top,
            width: e.FINAL_CONFIG.chart.padding.right - 1 + e.xPadding,
            height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
            fill: e.FINAL_CONFIG.chart.backgroundColor
          }, null, 8, pt)
        ]),
        e.FINAL_CONFIG.chart.grid.frame.show ? (l(), r("rect", {
          key: 3,
          style: { pointerEvents: "none", transition: "none" },
          x: e.drawingArea.left + e.xPadding < 0 ? 0 : e.drawingArea.left + e.xPadding,
          y: e.drawingArea.top,
          width: e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries) < 0 ? 0 : e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries),
          height: e.drawingArea.height < 0 ? 0 : e.drawingArea.height,
          fill: "transparent",
          stroke: e.FINAL_CONFIG.chart.grid.frame.stroke,
          "stroke-width": e.FINAL_CONFIG.chart.grid.frame.strokeWidth,
          "stroke-linecap": e.FINAL_CONFIG.chart.grid.frame.strokeLinecap,
          "stroke-linejoin": e.FINAL_CONFIG.chart.grid.frame.strokeLinejoin,
          "stroke-dasharray": e.FINAL_CONFIG.chart.grid.frame.strokeDasharray
        }, null, 8, Mt)) : c("", !0),
        e.FINAL_CONFIG.chart.grid.labels.show ? (l(), r("g", Pt, [
          t.mutableConfig.useIndividualScale ? (l(), r(I, { key: 0 }, [
            (l(!0), r(I, null, b(e.allScales, (a) => (l(), r("g", null, [
              u("line", {
                x1: a.x + e.xPadding,
                x2: a.x + e.xPadding,
                y1: t.mutableConfig.isStacked ? e.checkNaN(e.drawingArea.bottom - a.yOffset - a.individualHeight) : e.checkNaN(e.drawingArea.top),
                y2: t.mutableConfig.isStacked ? e.checkNaN(e.drawingArea.bottom - a.yOffset) : e.checkNaN(e.drawingArea.bottom),
                stroke: a.color,
                "stroke-width": e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-linecap": "round",
                style: L(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
              }, null, 12, Tt)
            ]))), 256)),
            (l(!0), r(I, null, b(e.allScales, (a) => (l(), r("g", {
              style: L(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
            }, [
              u("text", {
                fill: a.color,
                "font-size": t.fontSizes.dataLabels,
                "text-anchor": "middle",
                transform: `translate(${a.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth + 5}, ${t.mutableConfig.isStacked ? e.drawingArea.bottom - a.yOffset - a.individualHeight / 2 : e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`
              }, S(a.name) + " " + S(a.scaleLabel ? `- ${a.scaleLabel}` : ""), 9, Vt),
              (l(!0), r(I, null, b(a.yLabels, (o, n) => (l(), r("line", {
                x1: a.x - 3 + e.xPadding,
                x2: a.x + e.xPadding,
                y1: e.checkNaN(o.y),
                y2: e.checkNaN(o.y),
                stroke: a.color,
                "stroke-width": 1,
                "stroke-linecap": "round"
              }, null, 8, Rt))), 256)),
              (l(!0), r(I, null, b(a.yLabels, (o, n) => (l(), r("text", {
                x: a.x - 5 + e.xPadding,
                y: o.y + e.xPadding,
                "font-size": t.fontSizes.dataLabels,
                "text-anchor": "end",
                fill: a.color
              }, S(e.applyDataLabel(
                e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
                o.value,
                e.dataLabel({
                  p: e.FINAL_CONFIG.chart.labels.prefix,
                  v: o.value,
                  s: e.FINAL_CONFIG.chart.labels.suffix,
                  r: 1
                })
              )), 9, Dt))), 256))
            ], 4))), 256))
          ], 64)) : (l(!0), r(I, { key: 1 }, b(e.yLabels, (a, o) => (l(), r("g", {
            key: `yLabel_${o}`
          }, [
            e.canShowValue(a) && a.value >= e.niceScale.min && a.value <= e.niceScale.max ? (l(), r("line", {
              key: 0,
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left - 5 + e.xPadding,
              y1: e.checkNaN(a.y),
              y2: e.checkNaN(a.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              "stroke-linecap": "round"
            }, null, 8, Et)) : c("", !0),
            a.value >= e.niceScale.min && a.value <= e.niceScale.max ? (l(), r("text", {
              key: 1,
              x: e.drawingArea.left - 7 + e.xPadding,
              y: e.checkNaN(a.y + t.fontSizes.dataLabels / 3),
              "font-size": t.fontSizes.dataLabels,
              "text-anchor": "end",
              fill: e.FINAL_CONFIG.chart.grid.labels.color
            }, S(e.canShowValue(a.value) ? e.applyDataLabel(
              e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
              a.value,
              e.dataLabel({
                p: e.FINAL_CONFIG.chart.labels.prefix,
                v: a.value,
                s: e.FINAL_CONFIG.chart.labels.suffix,
                r: 1
              })
            ) : ""), 9, Ht)) : c("", !0)
          ]))), 128))
        ])) : c("", !0),
        (l(!0), r(I, null, b(e.plotSet, (a, o) => (l(), r("g", {
          key: `serie_plot_${o}`,
          class: M(`serie_plot_${o}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (l(!0), r(I, null, b(a.plots, (n, g) => (l(), r("g", {
            key: `circle_plot_${o}_${g}`
          }, [
            e.canShowValue(n.value) ? (l(), V(m, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(a.shape) ? a.shape : "circle",
              color: e.FINAL_CONFIG.plot.useGradient ? `url(#plotGradient_${o}_${t.uniqueId})` : a.color,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: t.selectedSerieIndex !== null && t.selectedSerieIndex === g || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === g ? (t.plotRadii.plot || 6) * 1.5 : t.plotRadii.plot || 6,
              stroke: e.FINAL_CONFIG.chart.backgroundColor,
              strokeWidth: 0.5
            }, null, 8, ["shape", "color", "plot", "radius", "stroke"])) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (l(), r("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              u("div", Bt, [
                v(i.$slots, "plot-comment", {
                  plot: { ...n, color: a.color }
                }, void 0, !0)
              ])
            ], 8, Wt)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(a, "useProgression") && a.useProgression === !0 && !isNaN(e.calcLinearProgression(a.plots).trend) ? (l(), r("g", Yt, [
            u("defs", null, [
              u("marker", {
                id: `plot_arrow_${o}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                u("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: a.color
                }, null, 8, qt)
              ], 8, Xt)
            ]),
            a.plots.length > 1 ? (l(), r("line", {
              key: 0,
              x1: e.calcLinearProgression(a.plots).x1,
              x2: e.calcLinearProgression(a.plots).x2,
              y1: e.calcLinearProgression(a.plots).y1,
              y2: e.calcLinearProgression(a.plots).y2,
              "stroke-width": 1,
              stroke: a.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#plot_arrow_${o})`
            }, null, 8, Zt)) : c("", !0),
            a.plots.length > 1 ? (l(), r("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(a.plots).x2,
              y: e.calcLinearProgression(a.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: a.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(a.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, Ut)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)),
        (l(!0), r(I, null, b(e.lineSet, (a, o) => (l(), r("g", {
          key: `serie_line_${o}`,
          class: M(`serie_line_${o}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          a.smooth && a.plots.length > 1 ? (l(), r("path", {
            key: 0,
            d: `M${a.curve}`,
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
            "stroke-dasharray": a.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, Jt)) : a.plots.length > 1 ? (l(), r("g", Kt, [
            (l(!0), r(I, null, b(a.plots, (n, g) => (l(), r("g", {
              key: `line_${o}_${g}`
            }, [
              n && g < a.plots.length - 1 && a.plots[g + 1] && e.canShowValue(n.value) && e.canShowValue(a.plots[g + 1].value) ? (l(), r("line", {
                key: 0,
                x1: n.x,
                x2: a.plots[g + 1].x,
                y1: n.y,
                y2: a.plots[g + 1].y,
                stroke: e.FINAL_CONFIG.chart.backgroundColor,
                "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
                "stroke-dasharray": a.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
                "stroke-linejoin": "round",
                "stroke-linecap": "round"
              }, null, 8, Qt)) : c("", !0)
            ]))), 128))
          ])) : c("", !0)
        ], 6))), 128)),
        (l(!0), r(I, null, b(e.lineSet, (a, o) => (l(), r("g", {
          key: `serie_line_${o}`,
          class: M(`serie_line_${o}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          a.useArea && a.plots.length > 1 ? (l(), r("g", jt, [
            a.smooth ? (l(), r("path", {
              key: 0,
              d: `M ${a.plots[0] ? a.plots[0].x : Math.min(...a.plots.filter((n) => !!n).map((n) => n.x))},${t.mutableConfig.isStacked ? e.drawingArea.bottom - a.yOffset : e.drawingArea.bottom} ${a.curve} L ${a.plots.at(-1) ? a.plots.at(-1).x : e.drawingArea.left + e.slot.line * o + e.slot.line / 2},${t.mutableConfig.isStacked ? e.drawingArea.bottom - a.yOffset : e.drawingArea.bottom} Z`,
              fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${o}_${t.uniqueId})` : `${a.color}${t.opacity[e.FINAL_CONFIG.line.area.opacity]}`
            }, null, 8, $t)) : (l(), r("path", {
              key: 1,
              d: `M${a.area}Z`,
              fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${o}_${t.uniqueId})` : `${a.color}${t.opacity[e.FINAL_CONFIG.line.area.opacity]}`
            }, null, 8, ea))
          ])) : c("", !0),
          a.smooth && a.plots.length > 1 ? (l(), r("path", {
            key: 1,
            d: `M${a.curve}`,
            stroke: a.color,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
            "stroke-dasharray": a.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, ta)) : a.plots.length > 1 ? (l(), r("g", aa, [
            (l(!0), r(I, null, b(a.plots, (n, g) => (l(), r("g", {
              key: `line_${o}_${g}`
            }, [
              n && g < a.plots.length - 1 && a.plots[g + 1] && e.canShowValue(n.value) && e.canShowValue(a.plots[g + 1].value) ? (l(), r("line", {
                key: 0,
                x1: n.x,
                x2: a.plots[g + 1].x,
                y1: n.y,
                y2: a.plots[g + 1].y,
                stroke: a.color,
                "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
                "stroke-dasharray": a.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
                "stroke-linejoin": "round",
                "stroke-linecap": "round"
              }, null, 8, ia)) : c("", !0)
            ]))), 128))
          ])) : c("", !0),
          (l(!0), r(I, null, b(a.plots, (n, g) => (l(), r("g", {
            key: `circle_line_${o}_${g}`
          }, [
            n && e.canShowValue(n.value) ? (l(), V(m, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(a.shape) ? a.shape : "circle",
              color: e.FINAL_CONFIG.line.useGradient ? `url(#lineGradient_${o}_${t.uniqueId})` : a.color,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: t.selectedSerieIndex !== null && t.selectedSerieIndex === g || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === g ? (t.plotRadii.line || 6) * 1.5 : t.plotRadii.line || 6,
              stroke: e.FINAL_CONFIG.chart.backgroundColor,
              strokeWidth: 0.5
            }, null, 8, ["shape", "color", "plot", "radius", "stroke"])) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (l(), r("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              u("div", ra, [
                v(i.$slots, "plot-comment", {
                  plot: { ...n, color: a.color }
                }, void 0, !0)
              ])
            ], 8, la)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(a, "useProgression") && a.useProgression === !0 && !isNaN(e.calcLinearProgression(a.plots).trend) ? (l(), r("g", sa, [
            u("defs", null, [
              u("marker", {
                id: `line_arrow_${o}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                u("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: a.color
                }, null, 8, oa)
              ], 8, na)
            ]),
            a.plots.length > 1 ? (l(), r("line", {
              key: 0,
              x1: e.calcLinearProgression(a.plots).x1,
              x2: e.calcLinearProgression(a.plots).x2,
              y1: e.calcLinearProgression(a.plots).y1,
              y2: e.calcLinearProgression(a.plots).y2,
              "stroke-width": 1,
              stroke: a.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#line_arrow_${o})`
            }, null, 8, ca)) : c("", !0),
            a.plots.length > 1 ? (l(), r("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(a.plots).x2,
              y: e.calcLinearProgression(a.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: a.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(a.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, ha)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)),
        (e.FINAL_CONFIG.bar.labels.show || e.FINAL_CONFIG.bar.serieName.show) && t.mutableConfig.dataLabels.show ? (l(), r("g", da, [
          (l(!0), r(I, null, b(e.barSet, (a, o) => (l(), r("g", {
            key: `xLabel_bar_${o}`,
            class: M(`xLabel_bar_${o}`),
            style: L(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (l(!0), r(I, null, b(a.plots, (n, g) => (l(), r("g", {
              key: `xLabel_bar_${o}_${g}`
            }, [
              n && (!Object.hasOwn(a, "dataLabels") || a.dataLabels === !0) && e.FINAL_CONFIG.bar.labels.show ? (l(), r("text", {
                key: 0,
                x: t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? n.x + e.slot.line / 2 : e.calcRectX(n) + e.calcRectWidth() / 2 - e.barPeriodGap / 2,
                y: n.y + (n.value > 0 ? e.FINAL_CONFIG.bar.labels.offsetY : -e.FINAL_CONFIG.bar.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.bar.labels.formatter,
                n.value,
                e.dataLabel({
                  p: e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.bar.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: a
                }
              ) : ""), 9, ua)) : c("", !0),
              n && e.FINAL_CONFIG.bar.serieName.show ? (l(), r("text", {
                key: 1,
                x: t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? n.x + e.slot.line / 2 : n.x + e.calcRectWidth() * 1.1,
                y: n.y + (n.value > 0 ? e.FINAL_CONFIG.bar.serieName.offsetY : -e.FINAL_CONFIG.bar.serieName.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.serieName.useSerieColor ? a.color : e.FINAL_CONFIG.bar.serieName.color,
                "font-weight": e.FINAL_CONFIG.bar.serieName.bold ? "bold" : "normal"
              }, S(e.FINAL_CONFIG.bar.serieName.useAbbreviation ? e.abbreviate({ source: a.name, length: e.FINAL_CONFIG.bar.serieName.abbreviationSize }) : a.name), 9, ga)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        e.FINAL_CONFIG.plot.labels.show && t.mutableConfig.dataLabels.show ? (l(), r("g", fa, [
          (l(!0), r(I, null, b(e.plotSet, (a, o) => (l(), r("g", {
            key: `xLabel_plot_${o}`,
            class: M(`xLabel_plot_${o}`),
            style: L(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (l(!0), r(I, null, b(a.plots, (n, g) => (l(), r("g", {
              key: `xLabel_plot_${o}_${g}`
            }, [
              n && !Object.hasOwn(a, "dataLabels") || a.dataLabels === !0 ? (l(), r("text", {
                key: 0,
                x: n.x,
                y: n.y + e.FINAL_CONFIG.plot.labels.offsetY,
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.plot.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.plot.labels.formatter,
                n.value,
                e.dataLabel({
                  p: e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.plot.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: a
                }
              ) : ""), 9, ma)) : c("", !0),
              n && g === 0 && a.useTag && a.useTag === "start" ? (l(), r("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: L(`padding: 3px; background:${a.color}${t.opacity[80]};color:${e.adaptColorToBackground(a.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(a.name), 5)
              ], 8, Ia)) : c("", !0),
              n && g === a.plots.length - 1 && a.useTag && a.useTag === "end" ? (l(), r("foreignObject", {
                key: 2,
                x: n.x - a.name.length * (t.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: L(`padding: 3px; background:${a.color}${t.opacity[80]};color:${e.adaptColorToBackground(a.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(a.name), 5)
              ], 8, ba)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        e.FINAL_CONFIG.line.labels.show && t.mutableConfig.dataLabels.show ? (l(), r("g", Na, [
          (l(!0), r(I, null, b(e.lineSet, (a, o) => (l(), r("g", {
            key: `xLabel_line_${o}`,
            class: M(`xLabel_line_${o}`),
            style: L(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (l(!0), r(I, null, b(a.plots, (n, g) => (l(), r("g", {
              key: `xLabel_line_${o}_${g}`
            }, [
              n && !Object.hasOwn(a, "dataLabels") || a.dataLabels === !0 ? (l(), r("text", {
                key: 0,
                x: n.x,
                y: n.y + (n.value > 0 ? e.FINAL_CONFIG.line.labels.offsetY : -e.FINAL_CONFIG.line.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.line.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.line.labels.formatter,
                n.value,
                e.dataLabel({
                  p: e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.line.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: a
                }
              ) : ""), 9, xa)) : c("", !0),
              n && g === 0 && a.useTag && a.useTag === "start" ? (l(), r("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: L(`padding: 3px; background:${a.color}${t.opacity[80]};color:${e.adaptColorToBackground(a.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(a.name), 5)
              ], 8, _a)) : c("", !0),
              n && g === a.plots.length - 1 && a.useTag && a.useTag === "end" ? (l(), r("foreignObject", {
                key: 2,
                x: n.x - a.name.length * (t.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: L(`padding: 3px; background:${a.color}${t.opacity[80]};color:${e.adaptColorToBackground(a.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(a.name), 5)
              ], 8, Fa)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        (l(!0), r(I, null, b(e.lineSet, (a, o) => (l(), r("g", {
          key: `xLabel_line_${o}`,
          class: M(`xLabel_line_${o}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (l(!0), r(I, null, b(a.plots, (n, g) => (l(), r("g", {
            key: `xLabel_line_${o}_${g}`
          }, [
            n && g === 0 && a.showSerieName && a.showSerieName === "start" ? (l(), r("text", {
              key: 0,
              x: n.x - t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: a.color,
              innerHTML: e.createTSpans({
                content: a.name,
                fontSize: t.fontSizes.plotLabels,
                fill: a.color,
                x: n.x - t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, ya)) : c("", !0),
            n && g === a.plots.length - 1 && a.showSerieName && a.showSerieName === "end" ? (l(), r("text", {
              key: 1,
              x: n.x + t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: a.color,
              innerHTML: e.createTSpans({
                content: a.name,
                fontSize: t.fontSizes.plotLabels,
                fill: a.color,
                x: n.x + t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Aa)) : c("", !0)
          ]))), 128))
        ], 6))), 128)),
        (l(!0), r(I, null, b(e.plotSet, (a, o) => (l(), r("g", {
          key: `xLabel_plot_${o}`,
          class: M(`xLabel_plot_${o}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (l(!0), r(I, null, b(a.plots, (n, g) => (l(), r("g", {
            key: `xLabel_plot_${o}_${g}`
          }, [
            n && g === 0 && a.showSerieName && a.showSerieName === "start" ? (l(), r("text", {
              key: 0,
              x: n.x - t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: a.color,
              innerHTML: e.createTSpans({
                content: a.name,
                fontSize: t.fontSizes.plotLabels,
                fill: a.color,
                x: n.x - t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, La)) : c("", !0),
            n && g === a.plots.length - 1 && a.showSerieName && a.showSerieName === "end" ? (l(), r("text", {
              key: 1,
              x: n.x + t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: a.color,
              innerHTML: e.createTSpans({
                content: a.name,
                fontSize: t.fontSizes.plotLabels,
                fill: a.color,
                x: n.x + t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Ca)) : c("", !0)
          ]))), 128))
        ], 6))), 128)),
        t.mutableConfig.useIndividualScale && !t.mutableConfig.isStacked ? (l(!0), r(I, { key: 8 }, b(e.allScales, (a) => (l(), r("rect", {
          x: a.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          y: e.drawingArea.top,
          width: e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
          fill: t.selectedScale === a.id ? `${a.color}20` : "transparent",
          onMouseenter: (o) => t.selectedScale = a.id,
          onMouseleave: s[0] || (s[0] = (o) => t.selectedScale = null)
        }, null, 40, Sa))), 256)) : c("", !0),
        u("g", null, [
          e.FINAL_CONFIG.chart.grid.labels.axis.yLabel && !t.mutableConfig.useIndividualScale ? (l(), r("text", {
            key: 0,
            "font-size": t.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color,
            transform: `translate(${t.fontSizes.yAxis + e.FINAL_CONFIG.chart.grid.labels.axis.yLabelOffsetX}, ${e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`,
            "text-anchor": "middle",
            style: { transition: "none" }
          }, S(e.FINAL_CONFIG.chart.grid.labels.axis.yLabel), 9, ka)) : c("", !0),
          e.FINAL_CONFIG.chart.grid.labels.axis.xLabel ? (l(), r("text", {
            key: 1,
            "text-anchor": "middle",
            x: t.width / 2,
            y: e.drawingArea.bottom + t.fontSizes.yAxis + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.axis.xLabelOffsetY,
            "font-size": t.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color
          }, S(e.FINAL_CONFIG.chart.grid.labels.axis.xLabel), 9, wa)) : c("", !0)
        ]),
        e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.show ? (l(), r("g", Oa, [
          (l(!0), r(I, null, b(e.timeLabels, (a, o) => (l(), r("g", {
            key: `time_label_${o}`
          }, [
            a && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || a && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (o === 0 || o === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || a && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && t.selectedSerieIndex === o && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || a && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && o % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0 ? (l(), r("text", {
              key: 0,
              "text-anchor": e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
              "font-size": t.fontSizes.xAxis,
              fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
              transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * o + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`
            }, S(a || ""), 9, va)) : c("", !0)
          ]))), 128))
        ])) : c("", !0),
        u("g", null, [
          (l(!0), r(I, null, b(e.maxSeries, (a, o) => (l(), r("g", {
            key: `tooltip_trap_${o}`
          }, [
            u("rect", {
              "data-cy-trap": "",
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * o,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: "transparent",
              onMouseenter: (n) => e.toggleTooltipVisibility(!0, o),
              onMouseleave: s[1] || (s[1] = (n) => e.toggleTooltipVisibility(!1)),
              onClick: (n) => e.selectX(o)
            }, null, 40, Ga)
          ]))), 128))
        ]),
        e.FINAL_CONFIG.chart.timeTag.show && ![null, void 0].includes(t.selectedSerieIndex) ? (l(), r("g", za, [
          (l(), r("foreignObject", {
            x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * t.selectedSerieIndex - 100 + e.drawingArea.width / e.maxSeries / 2,
            y: e.drawingArea.bottom,
            width: "200",
            height: "40",
            style: { overflow: "visible !important" }
          }, [
            u("div", {
              class: "vue-ui-xy-time-tag",
              style: L(`width: fit-content;margin: 0 auto;text-align:center;padding:3px 12px;background:${e.FINAL_CONFIG.chart.timeTag.backgroundColor};color:${e.FINAL_CONFIG.chart.timeTag.color};font-size:${e.FINAL_CONFIG.chart.timeTag.fontSize}px`)
            }, S(e.timeLabels[t.selectedSerieIndex] || t.selectedSerieIndex), 5)
          ], 8, pa)),
          u("circle", {
            cx: e.drawingArea.left + e.drawingArea.width / e.maxSeries * t.selectedSerieIndex + e.drawingArea.width / e.maxSeries / 2,
            cy: e.drawingArea.bottom,
            r: e.FINAL_CONFIG.chart.timeTag.circleMarker.radius,
            fill: e.FINAL_CONFIG.chart.timeTag.circleMarker.color
          }, null, 8, Ma)
        ])) : c("", !0)
      ])) : c("", !0),
      v(i.$slots, "svg", { svg: e.svg }, void 0, !0)
    ], 14, Xe)) : c("", !0),
    i.$slots.watermark ? (l(), r("div", Pa, [
      v(i.$slots, "watermark", W(B({ isPrinting: t.isPrinting || t.isImaging })), void 0, !0)
    ])) : c("", !0),
    e.isDataset ? c("", !0) : (l(), V(_, {
      key: 4,
      config: {
        type: "line",
        style: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          line: {
            axis: {
              color: e.FINAL_CONFIG.chart.grid.stroke
            },
            path: {
              color: e.FINAL_CONFIG.chart.grid.stroke,
              strokeWidth: 0.5
            }
          }
        }
      }
    }, null, 8, ["config"])),
    e.FINAL_CONFIG.chart.zoom.show && t.maxX > 6 && e.isDataset ? (l(), V(p, {
      ref: "chartSlicer",
      key: `slicer_${t.slicerStep}`,
      background: e.FINAL_CONFIG.chart.zoom.color,
      fontSize: e.FINAL_CONFIG.chart.zoom.fontSize,
      useResetSlot: e.FINAL_CONFIG.chart.zoom.useResetSlot,
      labelLeft: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t.slicer.start],
      labelRight: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t.slicer.end - 1],
      textColor: e.FINAL_CONFIG.chart.color,
      inputColor: e.FINAL_CONFIG.chart.zoom.color,
      selectColor: e.FINAL_CONFIG.chart.zoom.highlightColor,
      borderColor: e.FINAL_CONFIG.chart.backgroundColor,
      minimap: e.minimap,
      smoothMinimap: e.FINAL_CONFIG.chart.zoom.minimap.smooth,
      minimapSelectedColor: e.FINAL_CONFIG.chart.zoom.minimap.selectedColor,
      minimapSelectionRadius: e.FINAL_CONFIG.chart.zoom.minimap.selectionRadius,
      minimapLineColor: e.FINAL_CONFIG.chart.zoom.minimap.lineColor,
      minimapSelectedColorOpacity: e.FINAL_CONFIG.chart.zoom.minimap.selectedColorOpacity,
      minimapSelectedIndex: t.selectedSerieIndex,
      minimapIndicatorColor: e.FINAL_CONFIG.chart.zoom.minimap.indicatorColor,
      max: t.maxX,
      min: 0,
      valueStart: t.slicer.start,
      valueEnd: t.slicer.end,
      start: t.slicer.start,
      "onUpdate:start": s[2] || (s[2] = (a) => t.slicer.start = a),
      end: t.slicer.end,
      "onUpdate:end": s[3] || (s[3] = (a) => t.slicer.end = a),
      onReset: e.refreshSlicer,
      onTrapMouse: e.selectMinimapIndex
    }, {
      "reset-action": z(({ reset: a }) => [
        v(i.$slots, "reset-action", W(B({ reset: a })), void 0, !0)
      ]),
      _: 3
    }, 8, ["background", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "borderColor", "minimap", "smoothMinimap", "minimapSelectedColor", "minimapSelectionRadius", "minimapLineColor", "minimapSelectedColorOpacity", "minimapSelectedIndex", "minimapIndicatorColor", "max", "valueStart", "valueEnd", "start", "end", "onReset", "onTrapMouse"])) : c("", !0),
    e.FINAL_CONFIG.chart.legend.show ? (l(), r("div", {
      key: 6,
      ref: "chartLegend",
      class: "vue-ui-xy-legend",
      style: L(`font-size:${e.FINAL_CONFIG.chart.legend.fontSize}px`)
    }, [
      (l(!0), r(I, null, b(e.absoluteDataset, (a, o) => (l(), r("div", {
        key: `div_legend_item_${o}`,
        onClick: (n) => e.segregate(a),
        class: M({ "vue-ui-xy-legend-item": !0, "vue-ui-xy-legend-item-segregated": t.segregatedSeries.includes(a.id) })
      }, [
        t.icons[a.type] === "line" ? (l(), r("svg", Va, [
          u("rect", {
            x: "0",
            y: "7",
            rx: "3",
            stroke: "none",
            height: "4",
            width: "20",
            fill: a.color
          }, null, 8, Ra),
          Y(m, {
            plot: { x: 10, y: 9 },
            radius: 4,
            color: a.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(a.shape) ? a.shape : "circle",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            strokeWidth: 1
          }, null, 8, ["color", "shape", "stroke"])
        ])) : (l(), r("svg", Da, [
          t.icons[a.type] === "bar" ? (l(), r("rect", {
            key: 0,
            x: "0",
            y: "0",
            rx: "1",
            height: "12",
            width: "12",
            stroke: "none",
            fill: a.color
          }, null, 8, Ea)) : (l(), V(m, {
            key: 1,
            plot: { x: 6, y: 6 },
            radius: 5,
            color: a.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(a.shape) ? a.shape : "circle"
          }, null, 8, ["color", "shape"]))
        ])),
        u("span", {
          style: L(`color:${e.FINAL_CONFIG.chart.legend.color}`)
        }, S(a.name), 5)
      ], 10, Ta))), 128))
    ], 4)) : (l(), r("div", Ha, [
      v(i.$slots, "legend", { legend: e.absoluteDataset }, void 0, !0)
    ], 512)),
    Y(k, {
      show: t.mutableConfig.showTooltip && t.isTooltip,
      backgroundColor: e.FINAL_CONFIG.chart.tooltip.backgroundColor,
      color: e.FINAL_CONFIG.chart.tooltip.color,
      fontSize: e.FINAL_CONFIG.chart.tooltip.fontSize,
      borderRadius: e.FINAL_CONFIG.chart.tooltip.borderRadius,
      borderColor: e.FINAL_CONFIG.chart.tooltip.borderColor,
      borderWidth: e.FINAL_CONFIG.chart.tooltip.borderWidth,
      backgroundOpacity: e.FINAL_CONFIG.chart.tooltip.backgroundOpacity,
      position: e.FINAL_CONFIG.chart.tooltip.position,
      offsetY: e.FINAL_CONFIG.chart.tooltip.offsetY,
      parent: i.$refs.chart,
      content: e.tooltipContent,
      isCustom: e.FINAL_CONFIG.chart.tooltip.customFormat && typeof e.FINAL_CONFIG.chart.tooltip.customFormat == "function"
    }, {
      "tooltip-before": z(() => [
        v(i.$slots, "tooltip-before", W(B({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      "tooltip-after": z(() => [
        v(i.$slots, "tooltip-after", W(B({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      _: 3
    }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
    e.isDataset ? (l(), V(C, {
      key: 8,
      hideDetails: "",
      config: {
        open: t.mutableConfig.showTable,
        maxHeight: 1e4,
        body: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        },
        head: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        }
      }
    }, {
      content: z(() => [
        u("div", {
          style: L(`${t.isPrinting ? "" : "max-height:400px"};overflow:auto;width:100%;margin-top:48px`)
        }, [
          u("div", Wa, [
            Re(u("input", {
              type: "checkbox",
              "onUpdate:modelValue": s[4] || (s[4] = (a) => t.showSparklineTable = a)
            }, null, 512), [
              [De, t.showSparklineTable]
            ]),
            u("div", {
              onClick: s[5] || (s[5] = (a) => t.showSparklineTable = !t.showSparklineTable),
              style: { cursor: "pointer" }
            }, [
              Y(w, {
                name: "chartLine",
                size: 20,
                stroke: e.FINAL_CONFIG.chart.color
              }, null, 8, ["stroke"])
            ])
          ]),
          t.showSparklineTable ? (l(), V(G, {
            key: `sparkline_${t.segregateStep}`,
            dataset: e.tableSparklineDataset,
            config: e.tableSparklineConfig
          }, null, 8, ["dataset", "config"])) : (l(), V(x, {
            key: 1,
            colNames: e.dataTable.colNames,
            head: e.dataTable.head,
            body: e.dataTable.body,
            config: e.dataTable.config,
            title: `${e.FINAL_CONFIG.chart.title.text}${e.FINAL_CONFIG.chart.title.subtitle.text ? ` : ${e.FINAL_CONFIG.chart.title.subtitle.text}` : ""}`,
            onClose: s[6] || (s[6] = (a) => t.mutableConfig.showTable = !1)
          }, {
            th: z(({ th: a }) => [
              u("div", { innerHTML: a }, null, 8, Ba)
            ]),
            td: z(({ td: a }) => [
              Ee(S(isNaN(Number(a)) ? a : e.dataLabel({
                p: e.FINAL_CONFIG.chart.labels.prefix,
                v: a,
                s: e.FINAL_CONFIG.chart.labels.suffix,
                r: e.FINAL_CONFIG.table.rounding
              })), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ], 4)
      ]),
      _: 1
    }, 8, ["config"])) : c("", !0)
  ], 14, Ye);
}
const si = /* @__PURE__ */ He(Be, [["render", Ya], ["__scopeId", "data-v-f31b1c41"]]);
export {
  si as default
};
